﻿using DLVRNewDemo.Models;
using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Spreadsheet;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DLVRNewDemo.Templates
{
    public class ChildIPATemplate:BaseIPATemplate
    {
        private uint startRow = 11;
        private uint endRow = 0;
        private char headerStartCell = 'A';
        private char valueStartCell = 'O';
        private TestModel modelData;

        public ChildIPATemplate(TestModel testModels )
        {
            modelData = testModels;
           
        }

        public override void GenerateDynamicContent(DocumentFormat.OpenXml.Spreadsheet.SheetData sheetData)
        {
            uint rowIndex = startRow;
            foreach (var compDetail in modelData.CompenstaionComponent)
            {
                Row row = new Row() { RowIndex = rowIndex };
                row.DyDescent = 0.3D;
                row.ThickBot = true;
                row.Height = 16.5D;
                row.Spans = new ListValue<StringValue>() { InnerText = "1:39" };
                Cell header = new Cell() { CellReference = string.Format("{0}{1}", headerStartCell, rowIndex), StyleIndex = (UInt32Value)2U };
                header.CellValue = new CellValue(compDetail.ComponentName);
                row.Append(header);
                this.AppendRestOfTheCells(row);
                sheetData.Append(row);
                rowIndex++;
                foreach (var calcDetail in modelData.CalculationComponent[compDetail.Id])
                {
                    Row row1 = new Row() { RowIndex = rowIndex };
                    Cell headerCell = new Cell() { CellReference = string.Format("{0}{1}", headerStartCell, rowIndex), StyleIndex = (UInt32Value)8U };
                    headerCell.CellValue = new CellValue(calcDetail.Name);
                    Cell valueCell = new Cell() { CellReference = string.Format("{0}{1}", valueStartCell, rowIndex), StyleIndex = (UInt32Value)8U };
                    valueCell.CellValue = new CellValue(calcDetail.value);
                    row1.Append(headerCell);
                    row1.Append(valueCell);
                    sheetData.Append(row1);
                    rowIndex++;
                }

                Row emptyRow = new Row() { RowIndex = rowIndex };
                sheetData.Append(emptyRow);
                rowIndex++;
            }
        }

        private void AppendRestOfTheCells(Row row)
        {
            //List<string> cells = new List<string>();
            //this.GenerateCellRef(39, cells);
            //cells.Remove("A");
            //cells.Remove("O");
            //foreach (var cell in cells)
            //{
            //    Cell newCell = new Cell() { CellReference = string.Format("{0}{1}", cell, row.RowIndex) };
            //    row.Append(newCell);
            //}
        }
    }
}
