﻿using DLVRNewDemo.Models;
using DLVRNewDemo.Templates;
using DocumentFormat.OpenXml.Packaging;
using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DLVRNewDemo.ViewModels
{
    public class TestViewModel:INotifyPropertyChanged
    {
        private CompenstaionComponent selectedCompensationComponent;
        private List<CalculationComponents> selectedCalculationComponents;

        public TestModel Model { get; set; }
        public Commands PrintButtonClick { get; set; }
        public Commands SaveButtonClick { get; set; }
        public ObservableCollection<CompenstaionComponent> CompensationComponentCollection { get; set; }
        public ObservableCollection<CalculationComponents> CalculationComponentCollection { get; set; }
        public CompenstaionComponent SelectedCompensationComponent
        {
            get { return this.selectedCompensationComponent; }
            set
            {
                this.selectedCompensationComponent = value;
                this.OnPropertyChanged("SelectedCompensationComponent");
            }
        }

        public List<CalculationComponents> SelectedCalculationComponent
        {
            get { return this.selectedCalculationComponents; }
            set
            {
                this.selectedCalculationComponents = value;
                this.OnPropertyChanged("SelectedCalculationComponent");
            }
        }

        public TestViewModel()
        {
            this.PrintButtonClick = new Commands(PrintButtonClickHandler);
            this.SaveButtonClick = new Commands(SaveButtonClickhandler);
            this.GenrateCalculationComponents();
            this.GenerateCompensationComponents();
            Model = new TestModel();
          
        }

        private void GenerateCompensationComponents()
        {
            CompensationComponentCollection = new ObservableCollection<CompenstaionComponent>();
            var comp1 = new CompenstaionComponent() { Id = 1, ComponentName = "Basic Salary" };
            var comp3 = new CompenstaionComponent() { Id = 2, ComponentName = "Basic Salary1" };
            var comp2 = new CompenstaionComponent() { Id = 3, ComponentName = "ActualBonus" };
            var comp4 = new CompenstaionComponent() { Id = 4, ComponentName = "ActualBonus2" };
            var Calculation1 = new ObservableCollection<CalculationComponents>();
            Calculation1.Add(new CalculationComponents() { Name = "NumberRecieving", value = "20" });
            Calculation1.Add(new CalculationComponents() { Name = "75th %ile", value = "75" });
            Calculation1.Add(new CalculationComponents() { Name = "25th %ile", value = "25" });
            var Calculation2 = new ObservableCollection<CalculationComponents>();
            Calculation2.Add(new CalculationComponents() { Name = "NumberRecieving", value = "100" });
            Calculation2.Add(new CalculationComponents() { Name = "75th %ile", value = "200" });
            Calculation2.Add(new CalculationComponents() { Name = "25th %ile", value = "300" });
            var Calculation3 = new ObservableCollection<CalculationComponents>();
            Calculation3.Add(new CalculationComponents() { Name = "NumberRecieving", value = "100" });
            Calculation3.Add(new CalculationComponents() { Name = "75th %ile", value = "200" });
            Calculation3.Add(new CalculationComponents() { Name = "25th %ile", value = "300" });
            var Calculation4 = new ObservableCollection<CalculationComponents>();
            Calculation4.Add(new CalculationComponents() { Name = "NumberRecieving", value = "100" });
            Calculation4.Add(new CalculationComponents() { Name = "75th %ile", value = "200" });
            Calculation4.Add(new CalculationComponents() { Name = "25th %ile", value = "300" });
            comp1.CalcComponents = Calculation1;
            comp1.CalcComponents1 = Calculation1;
            comp2.CalcComponents = Calculation2;
            comp2.CalcComponents1 = Calculation2;
            comp3.CalcComponents = Calculation3;
            comp3.CalcComponents1 = Calculation3;
            comp4.CalcComponents = Calculation4;
            comp4.CalcComponents1 = Calculation4;
            this.CompensationComponentCollection.Add(comp1);
            this.CompensationComponentCollection.Add(comp2);
            this.CompensationComponentCollection.Add(comp3);
            this.CompensationComponentCollection.Add(comp4);
        }

        private void GenrateCalculationComponents()
        {
            CalculationComponentCollection = new ObservableCollection<CalculationComponents>();
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "NumberRecieving", value = "20" });
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "75th %ile", value = "75" });
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "25th %ile", value = "25" });
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "NumberRecieving", value = "100" });
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "75th %ile", value = "200" });
            CalculationComponentCollection.Add(new CalculationComponents() { Name = "25th %ile", value = "300" });
        }

        private void PrintButtonClickHandler(object parameter)
        {
            new ChildIPATemplate(Model).CreatePackage(@"C:\Users\A0745221\Desktop\NewTest\test.xlsx");
        }

        private void SaveButtonClickhandler(object parameter)
        {
            Model.CompenstaionComponent = CompensationComponentCollection.ToList();
            Model.CalculationComponent.Add(1, this.CalculationComponentCollection.ToList());
            Model.CalculationComponent.Add(2, this.CalculationComponentCollection.ToList());
            
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propName)
        {
            if(PropertyChanged !=null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
            }
        }
    }
}
