﻿using DLVRNewDemo.Models;
using DLVRNewDemo.ViewModels;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DLVRNewDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private int overIndex; 
        public MainWindow()
        {
            InitializeComponent();
        }
        /// <summary>
        /// method to handle drop event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void grdDataElementCollectionDrop(object sender, DragEventArgs e)
        {
            ObservableCollection<CompenstaionComponent> CompencomponentCollection = new ObservableCollection<CompenstaionComponent>();
            //ObservableCollection<SiteDataElementComponent> tempSelectedDataElementsList = new BusinessComponentList<SiteDataElementComponent>();
            //overIndex = overIndex - 1;

            ObservableCollection<CompenstaionComponent> selectedItems = e.Data.GetData(e.Data.GetFormats()[0]) as ObservableCollection<CompenstaionComponent>;
            foreach (var recrod in selectedItems)
            {
                if (overIndex >= 0 && overIndex <= ((TestViewModel)this.DataContext).CompensationComponentCollection.Count - 1)
                {  
                CompencomponentCollection.Add(recrod);
                }
            }

            if (CompencomponentCollection.Count > 0)
            {
                foreach (var item in CompencomponentCollection)
                {
                    if (overIndex >= 0 && overIndex <= ((TestViewModel)this.DataContext).CompensationComponentCollection.Count - 1)
                    {
                        XamDataGrid dataGrid = sender as XamDataGrid;
                        dataGrid.DefaultFieldLayout.SortedFields.Clear();

                        int itemIndex = ((TestViewModel)this.DataContext).CompensationComponentCollection.IndexOf(item);
                        ((TestViewModel)this.DataContext).CompensationComponentCollection.Move(itemIndex, overIndex);
                    }
                }
                overIndex = -1;
            }
            if (grdElementCollection.ActiveRecord != null)
                grdElementCollection.ActiveRecord.IsSelected = true;
        }

        /// <summary>
        /// Add the selected  items to available dataelements Grid, using drag operation
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XamDataGridMouseDownOnSelectedDataElements(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            if (grdElementCollection != null)
            {
                grdElementCollection.AllowDrop = true;

                Application.Current.Dispatcher.BeginInvoke(new Action(() =>
                {
                    ObservableCollection<CompenstaionComponent> selectedItems = new ObservableCollection<CompenstaionComponent>();
                    if (grdElementCollection.Records.Any(x => x.IsSelected))
                    {
                        foreach (Record record in grdElementCollection.Records.Where(x => x.IsSelected))
                        {
                            if (record is DataRecord)
                            {
                                selectedItems.Add((record as DataRecord).DataItem as CompenstaionComponent);
                            }
                        }
                        DragDrop.DoDragDrop(sender as DependencyObject, selectedItems, DragDropEffects.Move);
                    }

                }), System.Windows.Threading.DispatcherPriority.Render, null);
            }
        }
        /// <summary>
        /// method to get current index
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void grdDataElementCollectionDragOver(object sender, DragEventArgs e)
        {
            DataRecordPresenter dragOver = Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;
            XamDataGrid grid = (XamDataGrid)sender;

            var selectedItems = e.Data.GetData(e.Data.GetFormats()[0]) as ObservableCollection<CompenstaionComponent>;

            if (dragOver != null)
            {
                grid.ActiveRecord = dragOver.Record;
                if (grid.ActiveRecord != null)
                {
                    grid.ExecuteCommand(DataPresenterCommands.RecordAbove);
                    grid.ActiveRecord = null;
                }
                overIndex = dragOver.Record.VisibleIndex;
            }

            if (selectedItems != null && selectedItems.Any())
            {
                List<DataRecord> selectedRecords = new List<DataRecord>();
                //foreach (var item in selectedItems)
                foreach (var item in grid.Records)
                {
                    var record = (item as DataRecord).DataItem as CompenstaionComponent;
                    if (selectedItems.Any(x => x.Id == record.Id))
                    {
                        selectedRecords.Add(item as DataRecord);
                    }
                }
                grid.SelectedItems.Records.Clear();
                grid.SelectedItems.Records.AddRange(selectedRecords.ToArray(), false, true);
            }
        }
        private void DragSource_DragEnter(object sender, Infragistics.DragDrop.DragDropCancelEventArgs e)
        {

        }
    }
}
